#ifndef _SYS_RIO_H_
#define	_SYS_RIO_H_

struct rio_reg {
	dev_t	dev;			/* device associated with page */
	daddr_t	blkno;			/* disk block number */
	int	flags;			/* see below */
	long	size;			/* valid bytes in buffer */
	int	pagenum;		/* physical memory page, set and used
					    only in rio_dump */
};

/*
 * These flags are kept in Rio registry flags
 */
#define RIO_REG_VALID		0x01	/* entry is valid */
#define RIO_REG_CHANGING	0x02	/* page is being modified explictly by
					    kernel.  Checksum may not match */
#define RIO_REG_MMAP		0x04	/* page is mmap'ed and writable by
					    a user process.  Checksum may not
					    match */
#define RIO_REG_DIRTY		0x08	/* page has been modified and should
					    be written back to disk */

/* this is commented out because only the routines in rio.c should need
    to access the Rio registry */
/* extern struct rio_reg *rio_reg; */	/* virtual address of Rio registry */

void rio_init __P((void));
void rio_before_mod __P((struct buf *));
void rio_after_mod __P((struct buf *));
void rio_remove __P((vm_offset_t));
void rio_mmap __P((vm_page_t));
void rio_dump __P((void));

#endif /* !_SYS_RIO_H_ */
